package ru.bitheaven.createairfabric.mixin;

import com.llamalad7.mixinextras.injector.ModifyExpressionValue;
import com.simibubi.create.content.equipment.armor.BacktankItem;
import com.simibubi.create.content.equipment.armor.BacktankUtil;
import com.simibubi.create.content.equipment.armor.DivingHelmetItem;

import earth.terrarium.adastra.common.systems.OxygenApiImpl;
import earth.terrarium.adastra.common.tags.ModItemTags;
import net.minecraft.class_1304;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;

@Mixin(OxygenApiImpl.class)
public abstract class EntityOxygenSystemMixin {
    /**
     * Make air exists if Create Air
     */
    @ModifyExpressionValue(at = @At(value = "INVOKE", target = "Learth/terrarium/adastra/common/items/armor/SpaceSuitItem;hasOxygen(Lnet/minecraft/world/entity/Entity;)Z"),
            method = "entityTick(Lnet/minecraft/server/level/ServerLevel;Lnet/minecraft/world/entity/LivingEntity;)V")
    private boolean redirectHasOxygen(boolean original, class_3218 level, class_1309 entity) {
        boolean createOxygen = true;
        createOxygen &= !DivingHelmetItem.getWornItem(entity).method_7960();
        createOxygen &= !BacktankUtil.getAllWithAir(entity).isEmpty();
        return original || createOxygen;
    }
    @ModifyExpressionValue(at = @At(value = "INVOKE", target = "Learth/terrarium/adastra/common/items/armor/SpaceSuitItem;hasFullSet(Lnet/minecraft/world/entity/LivingEntity;)Z"),
            method = "entityTick(Lnet/minecraft/server/level/ServerLevel;Lnet/minecraft/world/entity/LivingEntity;)V")
    private boolean redirectHasFullSet(boolean original, class_3218 level, class_1309 entity) {
        boolean createArmor = true;
        createArmor &= entity.method_6118(class_1304.field_6169).method_7909() instanceof DivingHelmetItem;
        createArmor &= entity.method_6118(class_1304.field_6174).method_7909() instanceof BacktankItem;
        createArmor &= entity.method_6118(class_1304.field_6172).method_31573(ModItemTags.SPACE_SUITS);
        createArmor &= entity.method_6118(class_1304.field_6166).method_31573(ModItemTags.SPACE_SUITS);

        return original || createArmor;
    }
}

